/*



*/

import java.time.Instant;
import java.time.Duration;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.io.IOException;
import java.io.File;
import java.io.FileInputStream;
import java.util.Scanner;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.Path;

public class CountLines_v1_Files
{
   private static long totalByteCounter = 0;
   private static long totalLineCounter = 0;

   public static void main(String[] args) throws IOException
   {
      final SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss");
      System.out.println(ft.format(new Date()) + " Count lines in all Files ver 1");
      Instant start = Instant.now();

      Files.list(Paths.get("."))
             .parallel() // doesn't seem to do anything
               .filter(p -> p.toString().endsWith(".txt"))
                 .forEach(p -> countInFile(p)); // files are processed sequentially

      Instant stop = Instant.now();
      long time = Duration.between(start, stop).toMillis();
      System.out.printf("%s %,d bytes read from all files.\n",
                        ft.format(new Date()), totalByteCounter);
      System.out.printf("%s %,d lines read from all files.\n",
                        ft.format(new Date()), totalLineCounter);
      System.out.printf("elapsed time: %,dms\n", time);
   }


   public static void countInFile(Path path)
   {
      long byteCounter = 0;
      long lineCounter = 0;

      try
      {
         final String fileName = path.getFileName().toString();
         final Scanner scanner = new Scanner(new FileInputStream(fileName));
       //final Scanner scanner = new Scanner(new File(fileName)); // Why doesn't this work??

         while ( scanner.hasNextLine() )
         {
            ++lineCounter;
            byteCounter += 1 + scanner.nextLine().length();
         }

         totalByteCounter += byteCounter;
         totalLineCounter += lineCounter;
         scanner.close();
      }
      catch(IOException e){throw new Error(e);}
   }
}
