/*



*/

import java.io.*;
import java.util.Scanner;
import java.nio.file.*;

public class Count_Bytes_v1_Files
{
   private static long totalByteCounter = 0;

   public static void main(String[] args) throws IOException
   {
      Files.list(Paths.get("."))
             .parallel() // doesn't seem to do anything
               .filter(p -> p.toString().endsWith(".txt"))
                 .forEach(p -> countInFile(p));

      System.out.printf("%,d bytes read from all files\n", totalByteCounter);
   }


   public static void countInFile(Path path)
   {
      long byteCounter = 0;

      try
      {
         final String fileName = path.getFileName().toString();
         final Scanner scanner = new Scanner(new FileInputStream(fileName));
       //final Scanner scanner = new Scanner(new File(fileName)); // Why doesn't this work??

         while ( scanner.hasNextLine() )
         {
            byteCounter += 1 + scanner.nextLine().length();
         }

         totalByteCounter += byteCounter;
         scanner.close();
      }
      catch(IOException e){throw new Error(e);}
   }
}
